"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Enex_enexElement;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Enex = void 0;
const iso8601datetime_1 = require("./src/iso8601datetime");
const note_1 = require("./src/note");
const node_html_parser_1 = require("node-html-parser");
class Enex {
    constructor(enex) {
        _Enex_enexElement.set(this, void 0);
        const document = (0, node_html_parser_1.parse)(enex);
        const element = document.querySelector("en-export");
        if (!element)
            throw new Error("Invalid enex file. Must contain en-export element.");
        __classPrivateFieldSet(this, _Enex_enexElement, element, "f");
        this.validate();
    }
    get exportDate() {
        const exportDate = __classPrivateFieldGet(this, _Enex_enexElement, "f").getAttribute("export-date");
        if (!exportDate)
            throw new Error("Invalid enex. export-date attribute is required.");
        const date = iso8601datetime_1.ISO8601DateTime.toDate(exportDate);
        if (!date)
            throw new Error("export-date value is not a valid date.");
        return date;
    }
    get application() {
        const application = __classPrivateFieldGet(this, _Enex_enexElement, "f").getAttribute("application");
        if (!application)
            throw new Error("Invalid enex. application attribute is required.");
        return application;
    }
    get version() {
        const version = __classPrivateFieldGet(this, _Enex_enexElement, "f").getAttribute("version");
        if (!version)
            throw new Error("Invalid enex. version attribute is required.");
        return version;
    }
    get notes() {
        const noteElements = __classPrivateFieldGet(this, _Enex_enexElement, "f").querySelectorAll("note");
        if (noteElements.length <= 0)
            throw new Error("Invalid enex. Enex file contains 0 notes.");
        const notes = [];
        for (let element of noteElements) {
            notes.push(new note_1.Note(element));
        }
        return notes;
    }
    get isNotebook() {
        const noteElements = __classPrivateFieldGet(this, _Enex_enexElement, "f").querySelectorAll("note");
        return noteElements.length > 1;
    }
    validate() {
        this.exportDate && this.application && this.version && this.notes;
    }
}
exports.Enex = Enex;
_Enex_enexElement = new WeakMap();
