import { Resource } from "./resource";
import { Task } from "./task";
import { IEnexElement } from "./types";
import { HTMLElement } from "node-html-parser";
import { Content } from "./content";
export declare class Note implements IEnexElement {
    #private;
    constructor(noteElement: HTMLElement);
    get title(): string;
    get content(): Content;
    get created(): Date | null;
    get updated(): Date | null;
    get tags(): string[] | undefined;
    get attributes(): NoteAttributes | null;
    get resources(): Resource[] | undefined;
    get tasks(): Task[] | undefined;
    validate(): void;
}
declare class NoteAttributes {
    #private;
    constructor(noteAttributesElement: HTMLElement);
    get author(): string | null;
    get subjectDate(): string | null;
    get latitude(): number | null;
    get longitude(): number | null;
    get altitude(): number | null;
    get source(): string | null;
    get sourceUrl(): string | null;
    get sourceApplication(): string | null;
    get reminderOrder(): number | null;
    get reminderTime(): Date | null;
    get reminderDoneTime(): Date | null;
    get placeName(): string | null;
    get contentClass(): string | null;
}
export {};
