"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Note_noteElement, _NoteAttributes_noteAttributesElement;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Note = void 0;
const resource_1 = require("./resource");
const task_1 = require("./task");
const utils_1 = require("./utils");
const content_1 = require("./content");
class Note {
    constructor(noteElement) {
        _Note_noteElement.set(this, void 0);
        __classPrivateFieldSet(this, _Note_noteElement, noteElement, "f");
        this.validate();
    }
    get title() {
        return (0, utils_1.getAsStringRequired)(__classPrivateFieldGet(this, _Note_noteElement, "f"), "title");
    }
    get content() {
        const tag = __classPrivateFieldGet(this, _Note_noteElement, "f").querySelector("content");
        if (!tag)
            throw new Error(`content is required.`);
        return new content_1.Content(tag);
    }
    get created() {
        return (0, utils_1.getAsDate)(__classPrivateFieldGet(this, _Note_noteElement, "f"), "created");
    }
    get updated() {
        return (0, utils_1.getAsDate)(__classPrivateFieldGet(this, _Note_noteElement, "f"), "updated");
    }
    get tags() {
        const tagElements = __classPrivateFieldGet(this, _Note_noteElement, "f").getElementsByTagName("tag");
        if (!tagElements.length)
            return;
        const tags = [];
        for (let element of tagElements) {
            if (!element.textContent)
                continue;
            tags.push(element.textContent);
        }
        return tags;
    }
    get attributes() {
        const noteAttributeElement = __classPrivateFieldGet(this, _Note_noteElement, "f").querySelector("note-attributes");
        if (!noteAttributeElement)
            return null;
        return new NoteAttributes(noteAttributeElement);
    }
    get resources() {
        const resourceElements = __classPrivateFieldGet(this, _Note_noteElement, "f").querySelectorAll("resource");
        if (!resourceElements.length)
            return;
        const resources = [];
        for (let element of resourceElements) {
            resources.push(new resource_1.Resource(element));
        }
        return resources;
    }
    get tasks() {
        const taskElements = __classPrivateFieldGet(this, _Note_noteElement, "f").querySelectorAll("task");
        if (!taskElements.length)
            return;
        const tasks = [];
        for (let element of taskElements) {
            tasks.push(new task_1.Task(element));
        }
        return tasks;
    }
    validate() {
        this.title && this.content;
    }
}
exports.Note = Note;
_Note_noteElement = new WeakMap();
class NoteAttributes {
    constructor(noteAttributesElement) {
        _NoteAttributes_noteAttributesElement.set(this, void 0);
        __classPrivateFieldSet(this, _NoteAttributes_noteAttributesElement, noteAttributesElement, "f");
    }
    get author() {
        return (0, utils_1.getAsString)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "author");
    }
    get subjectDate() {
        return (0, utils_1.getAsString)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "subject-date");
    }
    get latitude() {
        return (0, utils_1.getAsNumber)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "latitude");
    }
    get longitude() {
        return (0, utils_1.getAsNumber)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "longitude");
    }
    get altitude() {
        return (0, utils_1.getAsNumber)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "altitude");
    }
    get source() {
        return (0, utils_1.getAsString)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "source");
    }
    get sourceUrl() {
        return (0, utils_1.getAsString)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "source-url");
    }
    get sourceApplication() {
        return (0, utils_1.getAsString)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "source-application");
    }
    get reminderOrder() {
        return (0, utils_1.getAsNumber)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "reminder-order");
    }
    get reminderTime() {
        return (0, utils_1.getAsDate)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "reminder-time");
    }
    get reminderDoneTime() {
        return (0, utils_1.getAsDate)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "reminder-done-time");
    }
    get placeName() {
        return (0, utils_1.getAsString)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "place-name");
    }
    get contentClass() {
        return (0, utils_1.getAsString)(__classPrivateFieldGet(this, _NoteAttributes_noteAttributesElement, "f"), "content-class");
    }
}
_NoteAttributes_noteAttributesElement = new WeakMap();
