import { IEnexElement } from "./types";
import { HTMLElement } from "node-html-parser";
declare enum MimeTypes {
    GIF = "image/gif",
    JPEG = "image/jpeg",
    PNG = "image/png",
    WAV = "audio/wav",
    MPEG = "audio/mpeg",
    PDF = "application/pdf",
    INK = "application/vnd.evernote.ink"
}
export declare class Resource implements IEnexElement {
    #private;
    constructor(resourceElement: HTMLElement);
    get data(): string;
    get mime(): MimeTypes;
    get width(): number | null;
    get height(): number | null;
    get duration(): number | null;
    get alternateData(): string | null;
    get attributes(): ResourceAttributes | null;
    validate(): void;
}
declare class ResourceAttributes {
    #private;
    constructor(resourceAttributesElement: HTMLElement);
    get latitude(): number | null;
    get longitude(): number | null;
    get altitude(): number | null;
    get sourceUrl(): string | null;
    get hash(): string | null;
    get cameraMake(): string | null;
    get cameraModel(): string | null;
    get recoType(): string | null;
    get filename(): string | null;
    get attachment(): boolean | null;
}
export {};
