import { Reminder } from "./reminder";
import { DateUIOption, IEnexElement } from "./types";
import { HTMLElement } from "node-html-parser";
export declare enum TaskStatus {
    OPEN = "open",
    COMPLETED = "completed"
}
export declare class Task implements IEnexElement {
    #private;
    constructor(taskElement: HTMLElement);
    get title(): string;
    get created(): Date;
    get updated(): Date;
    get taskStatus(): TaskStatus;
    get inNote(): boolean;
    get taskFlag(): string;
    get sortWeight(): string;
    get noteLevelID(): string;
    get taskGroupNoteLevelID(): string;
    get dueDate(): Date | null;
    get dueDateUIOption(): DateUIOption | null;
    get timeZone(): string | null;
    get statusUpdated(): Date | null;
    get creator(): string | null;
    get lastEditor(): string | null;
    get reminder(): Reminder | null;
    validate(): void;
}
