"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Task_taskElement;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Task = exports.TaskStatus = void 0;
const reminder_1 = require("./reminder");
const utils_1 = require("./utils");
var TaskStatus;
(function (TaskStatus) {
    TaskStatus["OPEN"] = "open";
    TaskStatus["COMPLETED"] = "completed";
})(TaskStatus = exports.TaskStatus || (exports.TaskStatus = {}));
class Task {
    constructor(taskElement) {
        _Task_taskElement.set(this, void 0);
        __classPrivateFieldSet(this, _Task_taskElement, taskElement, "f");
    }
    get title() {
        return (0, utils_1.getAsStringRequired)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "title");
    }
    get created() {
        return (0, utils_1.getAsDateRequired)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "created");
    }
    get updated() {
        return (0, utils_1.getAsDateRequired)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "updated");
    }
    get taskStatus() {
        return (0, utils_1.getAsStringRequired)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "taskStatus");
    }
    get inNote() {
        return (0, utils_1.getAsBoolean)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "inNote");
    }
    get taskFlag() {
        return (0, utils_1.getAsStringRequired)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "taskFlag");
    }
    get sortWeight() {
        return (0, utils_1.getAsStringRequired)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "sortWeight");
    }
    get noteLevelID() {
        return (0, utils_1.getAsStringRequired)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "noteLevelID");
    }
    get taskGroupNoteLevelID() {
        return (0, utils_1.getAsStringRequired)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "taskGroupNoteLevelID");
    }
    get dueDate() {
        return (0, utils_1.getAsDate)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "dueDate");
    }
    get dueDateUIOption() {
        return ((0, utils_1.getAsString)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "dueDateUIOption"));
    }
    get timeZone() {
        return (0, utils_1.getAsString)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "timeZone");
    }
    get statusUpdated() {
        return (0, utils_1.getAsDate)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "statusUpdated");
    }
    get creator() {
        return (0, utils_1.getAsString)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "creator");
    }
    get lastEditor() {
        return (0, utils_1.getAsString)(__classPrivateFieldGet(this, _Task_taskElement, "f"), "lastEditor");
    }
    get reminder() {
        const reminderElement = __classPrivateFieldGet(this, _Task_taskElement, "f").querySelector("reminder");
        if (!reminderElement)
            return null;
        return new reminder_1.Reminder(reminderElement);
    }
    validate() {
        this.title &&
            this.created &&
            this.updated &&
            this.inNote &&
            this.taskFlag &&
            this.sortWeight &&
            this.noteLevelID &&
            this.taskGroupNoteLevelID;
    }
}
exports.Task = Task;
_Task_taskElement = new WeakMap();
